Imports Microsoft.VisualBasic
Imports System.Diagnostics
Imports System.Data
Imports System.Web.UI
Imports System.ComponentModel

Namespace rw
    Public Class EventlogDataSourceView
        Inherits DataSourceView

        Private _owner As EventlogDataSource

        Public Sub New(ByVal owner As IDataSource, ByVal viewName As String)
            MyBase.New(owner, viewName)
            _owner = owner
        End Sub

        Public Sub SetViewName(ByVal viewName As String)
            RaiseChangedEvent()
        End Sub

        Protected Overrides Function ExecuteSelect(ByVal arguments As System.Web.UI.DataSourceSelectArguments) As System.Collections.IEnumerable
            'arguments.RaiseUnsupportedCapabilitiesError(Me)
            Dim dt As New DataTable()
            dt.Columns.Add("Index", System.Type.GetType("System.Int32"))
            dt.Columns.Add("EntryType", System.Type.GetType("System.String"))
            dt.Columns.Add("TimeGenerated", System.Type.GetType("System.DateTime"))
            dt.Columns.Add("Source", System.Type.GetType("System.String"))
            dt.Columns.Add("UserName", System.Type.GetType("System.String"))
            dt.Columns.Add("MachineName", System.Type.GetType("System.String"))
            dt.Columns.Add("Message", System.Type.GetType("System.String"))

            Dim exc As Exception = Nothing
            Dim dv As DataView = Nothing
            Try
                Dim objEventLog As EventLog = New EventLog(_owner.GetEventlogName())
                Dim objEntries As EventLogEntryCollection = objEventLog.Entries
                Dim objEntry As EventLogEntry
                For Each objEntry In objEntries
                    Dim dr As DataRow = dt.NewRow()
                    dr("Index") = objEntry.Index
                    dr("EntryType") = objEntry.EntryType.ToString()
                    dr("TimeGenerated") = objEntry.TimeGenerated
                    dr("Source") = objEntry.Source
                    dr("UserName") = objEntry.UserName
                    dr("MachineName") = objEntry.MachineName
                    dr("Message") = objEntry.Message
                    dt.Rows.Add(dr)
                Next
                dv = New DataView(dt)
                dv.Sort = arguments.SortExpression
            Catch ex As Exception
                exc = ex
            End Try
            Dim statusEventArgs As New EventlogDataSourceStatusEventArgs(exc)
            OnSelected(statusEventArgs)
            If (exc IsNot Nothing And Not statusEventArgs.ExceptionHandled) Then
                Throw exc
            End If
            Return dv
        End Function

        Public Sub OnSelected(ByVal e As EventlogDataSourceStatusEventArgs)
            _owner.OnSelected(e)
        End Sub

        Private Function GetSortPropertyDescriptor(ByVal descriptors As PropertyDescriptorCollection, _
        ByVal sortExpression As String) As PropertyDescriptor
            Dim descriptor As PropertyDescriptor
            For Each descriptor In descriptors
                If (descriptor.Name.Equals(sortExpression, _
                        StringComparison.InvariantCultureIgnoreCase)) Then
                    Return descriptor
                End If
            Next
            Return Nothing
        End Function

        Public Sub RaiseChangedEvent()
            OnDataSourceViewChanged(EventArgs.Empty)
        End Sub

    End Class
End Namespace